/* class_loader Example */
/* this is far away from reality, but demonstrates the most important features
 * of libclass_loader. Comments welcome.
 *
 * martin f. krafft <madduck@debian.org> 2004.05.13.2152
 *
 * Todo:
 */

#include <iostream>
#include <s11n/cllite.h>

struct A
{
  A() { std::cout << "A()\n"; }
  virtual ~A() { std::cout << "~A()\n"; }

  virtual void fn() const = 0;
};

struct AA : public A
{
  AA() { std::cout << "AA()\n"; }
  virtual ~AA() { std::cout << "~AA()\n"; }

  virtual void fn() const { std::cout << "AA::fn()\n"; }
};

struct AAA : public AA
{
  AAA() { std::cout << "AAA()\n"; }
  virtual ~AAA() { std::cout << "~AAA()\n"; }

  virtual void fn() const { std::cout << "AAA::fn()\n"; }
};

s11n_CLASSLOADER_ABSTRACT_BASE(A);
s11n_CLASSLOADER_REGISTER(A,AA);
s11n_CLASSLOADER_REGISTER(A,AAA);

int main(void)
{
  A* a = cllite::classload<A>("AA");

  if (a) a->fn();

  if (a) delete a;

  return 0;
}
